Subject: Re: [PATCH block:for-3.3/core] cfq: merged request shouldn't jump to a different cfqq

From: Shaohua Li <[email-masked]>
Date: Fri, 06 Jan 2012 12:15:49 +0800

On Thu, 2012-01-05 at 19:22 -0800, Tejun Heo wrote:
> On Thu, Jan 5, 2012 at 7:34 PM, Shaohua Li <[email-masked]> wrote:
> >> That's how cfq has behaved before this recent plug merge breakage and
> >> IIRC why the cooperating queue thing is there.  If you want to change
> >> the behavior, that should be an explicit separate patch.
> > My point is both cooperating merge and the plug merge of different cfq
> > are merge, no reason we allow one but disallow the other. plug merge
> > isn't a breakage to me.
> 
> Isolation is pretty big deal for cfq and cross cfqq merging happening
> without cfq noticing it isn't gonna be helpful to the cause.  Why
> don't we merge bio's across different cfqq's then?
don't know. I don't think a tweak for merge impacts isolation so much.
For rotate disk, request size hasn't impact to request cost, so this
doesn't impact isolation. Even for ssd, big size request is more
efficient to dispatch. And we already have breakage of fairness for SSD,
such as no idle.